package no.bbs.bankid.bidcserver.loaders;

/**
 * Created by lkale on 28.10.2015.
 */
public class JavaLibraryPathLoader implements Loader {

    private final LoaderExecutor loaderExecutor;

    public JavaLibraryPathLoader(LoaderExecutor loaderExecutor) {
        this.loaderExecutor = loaderExecutor;
    }

    @Override
    public boolean load(StringBuilder messages) {
        String property = System.getProperty("java.library.path");
        messages.append("Looking in:");
        messages.append(LoaderExecutor.LINE_SEPARATOR);
        messages.append("java.library.path=");
        messages.append(property);
        messages.append(LoaderExecutor.LINE_SEPARATOR);

        return loaderExecutor.load("CAPI", messages);
    }
}
