package no.bbs.bankid.netcentric.centralverifier.communication;

import no.bbs.bankid.bidcserver.CServerLibrary;
/* 
Generate JNI header file with: 
        javah -classpath . -v -force -d <output directory> no.bbs.bankid.netcentric.centralverifier.communication.CAPI
*/
public class CAPI {

    public native String Initialize();

    public native String HSMInitialize(String pcks11driver);

    public native String Finalize();
    
    public native String[] OpenSession(String keylocation, String password, String configlocation, String webaddress, String tagcache, String trustedstore, String grantedpolicies, String proxyserver, String proxyport);

    public native String[] HSMOpenSession(String keylocation, String password, String configlocation, String webaddress, String tagcache, String trustedstore, String grantedpolicies, String proxyserver, String proxyport, String pkcs11password, int slot);

    public native String[] RAHSMOpenSession(String keylocation, String password, String pkcs11password, int slot);

    public native String CloseSession(int sessioncontext);
    
    public native String AuthenticateClient(int sessioncontext, String pkcs7, String serverchallenge);

    public native String VerifyHashData(int sessioncontext, String pkcs7, String hashofdata, int auth);

    public native String[] GetCertStatus(int sessioncontext, String pkcs7);

    public native String[] GetOwnCertStatus(int sessioncontext);

    public native String[] SDOFromXML(int sessioncontext, String sdoxml);

    public native String[] SDOToXML(int sessioncontext, String sdo);

    public native String SDOValidate(int sessioncontext, String sdo, int verifydata);

    public native String DynamicSDOValidate(int sessioncontext, String sdo, String data, int numsignatures, int sealcheck);

    public native String SDOXMLValidate(int sessioncontext, String sdo, int verifydata);

    public native String[] GetPKCS7Info(int sessioncontext, String pkcs7, int infoitem);

    public native String[] AssymetricDecrypt(int sessioncontext, String keylocation, String password, String encrypted);

    public native String[] SymetricDecrypt(int sessioncontext, String key, String encrypted);

    public native String[] SymetricEncrypt(int sessioncontext, String key, String decrypted);

    public native String[] SignData(int sessioncontext, byte[] data, int datalen);

    public native String[] SignXML(int sessioncontext, byte[] xml, int xmllen, byte[] xsl, int xsllen);

    public native String VerifyData(int sessioncontext, String pkcs7, byte[] data, int datalen);

    public native String[] GetInfoItem(int sessioncontext, String key);

    public native String SetInfoItem(int sessioncontext, String key, byte[] value);

    public native String[] HashData(int sessioncontext, int hashalgorithm, String data);

    public native String[] AuthenticateServer(int sessioncontext, String clientchallenge, String authenticationheader, String prepareText);

    public native String[] CreateSDO(int sessioncontext, String data, String datatype, String datadescription, String clientpkcs7, String serverpkcs7, String clientocspresponse, String serverocspresponse);

    public native String[] CreateDynamicSDO(int sessioncontext, String data, String datatype, String datadescription, String pkcs7_1, String pkcs7_2, String ocspresponse_1, String ocspresponse_2);

    public native String[] GetRecentError(int sessioncontext);

    public native String RemoveInfoItems(int sessioncontext);

    public native String SDOFree(int sessioncontext, String sdo);

    public native String[] CreateXMLDSIG(int sessioncontext, String c14nXmlOrder);

    public native String SDOSeal(int sessioncontext, String sdo, String ocsp, String data);

    public native String SDOAddSignature(int sessioncontext, String sdo, String data, String pkcs7_1, String pkcs7_2, String ocspresponse_1, String ocspresponse_2);

    public native String SDOAddData(int sessioncontext, String sdo, String data);

    public native String[] CreateSecureChannel(int sessioncontext, String pkcs7);

    public native String[] GetCertStatusWithNonce(int sessioncontext, String pkcs7);

    public native String[] GetSessionStoreInfo(int sessioncontext);

    public native String[] RequestMobileAction(int sessioncontext);

    public native String PushSms(int sessioncontext, String transactionreference, String text);

    public native String[] GetSigners(int sessioncontext, String[] signatures);

    public native String[] DynamicSDOGetSigners(int sessioncontext, String sdo);

    public native String[] DynamicSDOXMLGetSigners(int sessioncontext, String sdoXml);

    public native String SimpleDynamicSDOXMLValidate(int sessioncontext, String sdoXml, int minNumSignatures);

    /* public native String[] PrepareTextForMobile(int sessioncontext, String latinText); */

    public native String RequestMobileStatus(int sessioncontext, String transactionreference);

    public native String[] GenerateMerchantReference(int sessioncontext, String locale);

    public native String[] DecryptTransactionData(int sessioncontext, String enckey, String encdata, String encauth, String operation, String sid);

    public native String[] InitTransaction(int sessioncontext, String enckey, String encdata, String encauth, String operation, String sid);

    public native String VerifyTransactionRequest(int sessioncontext, String enckey, String encdata, String encauth, String operation, String sid);

    public native String[] VerifyTransactionResponse(int sessioncontext);

    public native String[] InitSession(int sessioncontext);

    public native String GetTransactionInfo(int sessioncontext, String key, String oids, String timeout);

    public native String AddDocumentText(int sessioncontext, String data, byte[] datadescription);

    public native String AddDocumentPdf(int sessioncontext, String data, byte[] datadescription);

    public native String AddDocumentXML(int sessioncontext, byte[] xml, byte[] xsl, byte[] datadescription);

    public native String[] GetSignedData(int sessioncontext, int docnum);
    
    public native String SetSignedData(int sessioncontext, String data);
	
    public native String[] GetSignatureAndOCSP(int sessioncontext, int docnum);

    public native String[] GetSignatureAndFullOCSP(int sessioncontext, int docnum);
	
    public native String[] GetReportData(int sessioncontext, String key);
}
